﻿local SellRuns = CreateFrame("Frame")
SellRuns:RegisterEvent("CHAT_MSG_WHISPER");
-- SellRuns:RegisterEvent("CHAT_MSG_BN_WHISPER");
SellRuns:RegisterEvent("PLAYER_LOGIN");
SellRuns:RegisterEvent("CHAT_MSG_ADDON");
SellRuns:RegisterEvent("MAIL_SEND_SUCCESS");
SellRuns:RegisterEvent("MAIL_FAILED");
SellRuns:RegisterEvent("MAIL_SHOW");
SellRuns:RegisterEvent("MAIL_CLOSED");
SellRuns:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST");
SellRuns:RegisterEvent("CALENDAR_OPEN_EVENT");

local t13old = {"DRAGON SOUL (Tier13): Madness of Deathwing Heroic mount |cffa335ee|Hitem:77069:0:0:0:0:0:0:0:85:0|h[Life-Binder's Handmaiden]|h|r (includes title) – 250k || Madness of Deathwing Heroic achievement + title ‘Savior of Azeroth’ alone – 130k", 
				"Spine + Madness of Deathwing Heroic (includes title) + (416 ilvl) loot – 180k + 35k/item || 6/8 Heroic run + (410 ilvl) loot – 100k + 15k / item",
				"All In One: Full 8/8 Heroic run + any loot (including Deathwing 416 ilvl ones, regardless of amount) + Savior of Azeroth title + |cffa335ee|Hitem:77069:0:0:0:0:0:0:0:85:0|h[Life-Binder's Handmaiden]|h|r – 350k",
				"NOTE:Buying everything at once also allows you to be taken on first week that also has not been fully bought out. This means that buying anything other than ‘all in one’ pack does not guarantee you a spot. Loot sold does not include items needed by us" }

local t13 = {"DRAGON SOUL (Tier13): Full 8/8 Heroic run + 'Savior of Azeroth' title + |cffa335ee|Hitem:77069:0:0:0:0:0:0:0:85:0|h[Life-Binder's Handmaiden]|h|r - 200k",
			 "Additional loot priviledges (loot order: our Main Spec > your Main Spec > our Off Spec > your Off Spec) - 50k",
			 "Without buying the additional loot priviledges your Main Spec goes under our Off Spec (you can still get loot, but your priority will be the lowest)",
			 "NOTE: We allow outbids even if week is already taken, meaning we take highest offer for each week. Outbids are at least 20k." }
				
local t12 = {"FIRELANDS (Tier12): Full Heroic run + Firelord title + |cffa335ee|Hitem:69224:0:0:0:0:0:0:0:85:0|h[Smoldering Egg of Millagazor]|h|r + any piece of loot (that drops; does not include legendary items)", 
				"NOTE: We take highest offer of each week according to bids done on the previous week. Prices are:",
				"Starting Bid – 100k || Minimum Outbid – 10k || Buyout (only on weeks that are not already closed) – 200k. Buyout means me closing a week for bidding and you getting a guaranteed spot.", 
				"If you are interested in knowing the current prices, please visit: http://eu.battle.net/wow/en/forum/topic/3295159483 or ask me ingame" }
local t11 = {"BWD/BoT/ToFW (Tier11): This tier is not a priority for us and therefore those prices are just a guideline of what we're aiming for.", 
				"Full Meta run (takes 2 weeks) for |cffa335ee|Hitem:62901:0:0:0:0:0:0:0:85:0|h[Reins of the Drake of the East Wind]|h|r – 300k || All Normal achievements – 150k || All Heroic achievements – 150k", 
				"Individual achievements that do not award a title – 20k/achievement || Heroic achievements awarding titles (includes ‘Blackwing’s Bane’ and ‘of the Four Winds’) – 35k/achievement",
				"Sinestra: ‘I Can't Hear You Over the Sound of How Awesome I Am’ achievement + 'Dragonslayer' title – 150k || ‘Dragonslayer’ title – 50k" }
				
local SellRunsDebug = true
local t13size = table.getn(t13)
local t12size = table.getn(t12)
local t11size = table.getn(t11)
local lastwhisper = 0	-- time of last whisper from sender
local spamTime = 10 -- seconds between whispers
local warnings = 3 -- warnings before autoignore
local interest = 0
local interestWhisper = 0
local syncDispFlag = false

-- Mailing
local SellRunsCanSend = false	-- true if it's possible to send another mail
local SellRunsElapsed = 0.0		-- time from mailbox being 'unlocked' after sending a mail
local SellRunsMailCurrent = 1	-- currently processed receiver
local MAX_MAIL_ENTRIES = 13
local SellRunsMailSubjectToSend = ""	-- subject string that is sent, can change every loop
local SellRunsMailBodyToSend = ""		-- body string that is sent, can change every loop
local SellRunsGoldToSend = 0
local SellRunsRequestedInvUpdate = false
local eventCount = 0
local curEvent = -1
local SellRunsCalendarElapsed = 0.0
local gbankStr = ""
local SellRunsPostage = 30		-- 30c, every receiver pays for own mail

-- UI
local MAX_ENTRIES = 13
local currSort = 0
local currOrder = "asc"
local globalTable = {""}

do
	local entry = CreateFrame("Button", "$parentEntry1", SellRuns_MainFormEntryList, "SellRuns_TableBrowserEntry")
	entry:SetID(1)
	entry:SetPoint("TOPLEFT", 4, -28)
	for i=2, MAX_ENTRIES do
		local entry = CreateFrame("Button", "$parentEntry"..i, SellRuns_MainFormEntryList, "SellRuns_TableBrowserEntry")
		entry:SetID(i)
		entry:SetPoint("TOP", "$parentEntry"..(i - 1), "BOTTOM")
	end
end

do
	local entry = CreateFrame("Button", "$parentEntry1", SellRuns_MailingEntryList, "SellRuns_MailingBrowserEntry")
	entry:SetID(1)
	entry:SetPoint("TOPLEFT", 4, -28)
	for i=2, MAX_MAIL_ENTRIES do
		local entry = CreateFrame("Button", "$parentEntry"..i, SellRuns_MailingEntryList, "SellRuns_MailingBrowserEntry")
		entry:SetID(i)
		entry:SetPoint("TOP", "$parentEntry"..(i - 1), "BOTTOM")
	end
end

function SellRunsDebugMsg(msg)
	if (SellRunsDebug) then
		local str = "SellRuns Debug: "
		ChatFrame1:AddMessage(str..msg)
	end
end

function SellRunsOnLoad()
	SLASH_SELLRUNS1 = '/sellruns'
		SlashCmdList["SELLRUNS"] = function(msg, editbox) SellRuns:SlashHandler(msg, editbox) end
		if type(SellRunsTradeDB ~= "table") then
			SellRunsTradeDB = {}
			SellRunsTradeDB[0] = {}
			SellRunsTradeDB[0]["trader1"] = ""
			SellRunsTradeDB[0]["trader2"] = ""
			SellRunsTradeDB[0]["date"] = ""
			SellRunsTradeDB[0]["time"] = ""
			SellRunsTradeDB[0]["goldIn"] = ""
			SellRunsTradeDB[0]["goldOut"] = ""
			SellRunsTradeDB[0]["itemsIn"] = {}
			SellRunsTradeDB[0]["itemsOut"] = {}
			SellRunsTradeDB[0]["location"] = ""
			SellRunsTradeDB[0]["result"] = 0
		end
		if (SellRunsMailSubject == nil) then
			SellRunsMailSubject = ""
		end
		if (SellRunsMailBody == nil) then
			SellRunsMailBody = ""
		end
		if (SellRunsMailReason == nil) then
			SellRunsMailReason = ""
		end
		if (SellRunsMailGold == nil) then
			SellRunsMailGold = ""
		end
		if (SellRunsEventName == nil) then
			SellRunsEventName = "Unavailable"
		end
		
		if type(SellRunsDB) == "table" then
			SellRunsFillTableAll()
			for itrname in pairs(SellRunsDB) do 
				local lastWhisper = SellRunsDB[itrname]["antiSpamTime"]
				if (lastWhisper > 0) then
					SellRunsDB[itrname]["antiSpamTime"] = 1
				end
			end	
		end
		SellRunsMailingQueueUpdate()
		RegisterAddonMessagePrefix("SellRuns")
end

function SellRunsOnWhisper(msg, sender)
	local seconds = GetTime()
	local curdate = date("%d/%m/%y")
	local curtime = date("%H:%M:%S")
	
	if (msg == "t13info" or msg == "t12info" or msg == "t11info") then
	
		if (msg == "t11info") then
			interestWhisper = 1
		end
		if (msg == "t12info") then
			interestWhisper = 2
		end
		if (msg == "t13info") then
			interestWhisper = 4
		end
		if type(SellRunsDB) ~= "table" then		-- initializing a new array
			SellRunsDB = {}
			SellRunsDB[sender] = {}
			SellRunsDB[sender]["antiSpamTime"] = seconds
			SellRunsDB[sender]["warnsRemaining"] = warnings
			SellRunsDB[sender]["date"] = curdate
			SellRunsDB[sender]["time"] = curtime
			SellRunsDB[sender]["interest"] = interestWhisper
			SellRunsDebugMsg('INIT Sender added: ' .. sender .. " Time: " .. seconds)
			--SellRunsDebugMsg('Date: ' .. curdate .. " Time: " .. curtime)
		else
			local found = 0
                for name in pairs(SellRunsDB) do 
                         if sender == name then
								local lastWhisper = SellRunsDB[sender]["antiSpamTime"]
								if (seconds - lastWhisper < spamTime) then		-- spam detected
									local warningsRemaining = SellRunsDB[sender]["warnsRemaining"]
									SellRunsDB[sender]["antiSpamTime"] = seconds
									SellRunsDB[sender]["date"] = curdate
									SellRunsDB[sender]["time"] = curtime
									if (warningsRemaining == 1) then
										SellRunsDB[sender]["warnsRemaining"] = -1
										SendChatMessage("Spam detection limit reached (3/3)! Autoignoring.", "WHISPER", nil, sender)
										AddIgnore(sender)
									else
										SellRunsDB[sender]["warnsRemaining"] = warningsRemaining - 1
										SendChatMessage("Spam detected (" .. (warnings-warningsRemaining+1) .. "/" ..  warnings .. "). Last whisper was done " .. string.sub((seconds - lastWhisper),1,3) .. "s ago. Please wait at least " .. spamTime .. "s between whispers.", "WHISPER", nil, sender)
									end
									return
								else
									SellRunsDB[sender]["warnsRemaining"] = warnings
								end
								SellRunsDB[sender]["antiSpamTime"] = seconds
								SellRunsDB[sender]["date"] = curdate
								SellRunsDB[sender]["time"] = curtime
								interest = SellRunsDB[sender]["interest"]
								interest = bit.bor(interest, interestWhisper)
								SellRunsDB[sender]["interest"] = interest
                                found = 1
                         end
                end
                if found == 0 then		-- adding new record
					SellRunsDB[sender] = {}
					SellRunsDB[sender]["antiSpamTime"] = seconds
					SellRunsDB[sender]["warnsRemaining"] = warnings
					SellRunsDB[sender]["date"] = curdate
					SellRunsDB[sender]["time"] = curtime
					SellRunsDB[sender]["interest"] = interestWhisper
					SellRunsDebugMsg('Sender not found, adding: ' .. sender)
            end
			--SellRunsDebugMsg('Sender added: ' .. sender .. " Time: " .. seconds)
		end
		
	end
	
	if (msg == "t13info") then
		for i=1, t13size, 1 do
			SendChatMessage(t13[i], "WHISPER", nil, sender)
		end
	end
	if (msg == "t12info") then
		for i=1, t12size, 1 do
			SendChatMessage(t12[i], "WHISPER", nil, sender)
		end
	end
	if (msg == "t11info") then
		for i=1, t11size, 1 do
			SendChatMessage(t11[i], "WHISPER", nil, sender)
		end
	end
	
	if (SellRuns_MainForm:IsShown()) then
		SellRunsUpdate()
	end
end

SellRuns:SetScript("OnEvent", function(self, event, ...)
	if (event == "PLAYER_LOGIN") then
		SellRunsOnLoad()
	end
	if (event == "CHAT_MSG_ADDON") then
		local prefix = select(1, ...)
		local msg = select(2, ...)
		local channel = select(3, ...)
		local sender = select(4, ...)
		--SellRunsDebugMsg("Prefix: " .. prefix .. " Msg: " .. msg .. " Channel: " .. channel .. " Sender: " .. sender)
		if (prefix ~= "SellRuns") then return end
		SellRuns:SyncReceiveHandler(prefix, msg, sender)
	end
	if (event == "CHAT_MSG_WHISPER") then
		local msg = select(1, ...)
		local sender = select(2, ...)
		SellRunsOnWhisper(msg, sender)
	end
	
	if (event == "CALENDAR_UPDATE_EVENT_LIST") then
		SellRunsCalendarInvitesHandler(event)
	end
	
	if (event == "CALENDAR_OPEN_EVENT") then
		SellRunsCalendarInvitesHandler(event)
	end
	
	if ( event == "MAIL_SEND_SUCCESS" ) then		-- called whem outgoing message is sent successfully
		SellRunsMailingAddToDB()
		SellRunsCanSend = true;
	elseif ( event == "MAIL_FAILED" ) then			-- called when outgoing message fails to send
		SellRunsMailFailed()
		SellRunsDebugMsg("MAIL_FAILED")
		SellRunsCanSend = true;
	elseif ( event == "MAIL_CLOSED" ) then			-- called when player ends interaction with mailbox
		SellRunsCanSend = false;
	elseif ( event == "MAIL_SHOW" ) then			-- called when player starts interaction with mailbox
		SellRunsCanSend = true;
	end
end)

SellRuns:SetScript("OnUpdate", function(self, elapsed, ...)
	if (SellRunsRequestedInvUpdate) then
		SellRunsCalendarElapsed = SellRunsCalendarElapsed + elapsed
		if (SellRunsCalendarElapsed > 0.5) then		-- wait a while, for dem safety
			SellRunsCalendarElapsed = 0.0
			local day = date("%d")
			CalendarOpenEvent(0, day, curEvent)
		end
	end

	if ( (not SellRunsCanSend) or (not SendMailSubjectEditBox:IsVisible()) or (SellRuns_MailingSend:GetButtonState() ~= "DISABLED")) then return end
	
	SellRunsElapsed = SellRunsElapsed + elapsed
	if (SellRunsElapsed > 0.5) then
		SellRunsElapsed = 0.0
		SellRunsMailProcess()
	end
end)

function SellRuns:SlashHandler(msg, editbox)
	local input, extraValue
	local sStart, sEnd = strfind(msg, "  ")
	if sStart and sEnd then
		input = strsub(msg, 1, sStart-1)
		extraValue = strsub(msg, sEnd+1)
	else
		local inputs = {strsplit(" ", msg)}
		input = inputs[1]
		extraValue = inputs[2]
		for i=3, #(inputs) do
			extraValue = extraValue .. " " .. inputs[i]
		end
	end
	if (input == "all" or input == "ignored") then
		if (msg == "all") then
			ChatFrame1:AddMessage("All Players")
		end
		if (input == "ignored") then
			ChatFrame1:AddMessage("Ignored Players")
		end
		for lname in pairs(SellRunsDB) do
			local str = ""
			if (bit.band(SellRunsDB[lname]["interest"], 1) == 1) then
				str = str .. "t11 "
			end
			if (bit.band(SellRunsDB[lname]["interest"], 2) == 2) then
				str = str .. "t12 "
			end
			if (bit.band(SellRunsDB[lname]["interest"], 4) == 4) then
				str = str .. "t13 "
			end
			lwarns = SellRunsDB[lname]["warnsRemaining"]
			ldate = SellRunsDB[lname]["date"]
			ltime = SellRunsDB[lname]["time"]
			antiSpamTime = SellRunsDB[lname]["antiSpamTime"]
			if (input == "ignored" and lwarns == -1) then
				ChatFrame1:AddMessage("Name: " .. lname .. " Warns left: " .. lwarns .. " Last whisper: " .. ldate .. " " .. ltime .. " Interests: " .. str)
			else if (input == "all") then
					--ChatFrame1:AddMessage("Name: " .. lname .. " Warns left: " .. lwarns .. " Last whisper: " .. ldate .. " " .. ltime .. " Interests: " .. str)
					ChatFrame1:AddMessage("Name: " .. lname .. " AntiSpam Time: " .. antiSpamTime .. " Last whisper: " .. ldate .. " " .. ltime .. " Interests: " .. str)
				 end
			end
		end
	end
	
	if (input == "ui") or (input == "") then
		if ( SellRuns_MainForm:IsShown() ) then
			SellRuns_MainForm:Hide()
		else
			SellRuns_MainForm:Show()
		end
	end
	
	if (input == "mail") or (input == "mailing") then
		if ( SellRuns_Mailing:IsShown() ) then
			SellRuns_Mailing:Hide()
		else
			SellRuns_Mailing:Show()
		end
	end
	
	if (input == "help") then
		ChatFrame1:AddMessage("/sellruns help - shows this message")
		ChatFrame1:AddMessage("/sellruns all - lists all players")
		ChatFrame1:AddMessage("/sellruns ignored - lists ignored players")
		ChatFrame1:AddMessage("/sellruns t13 Jackk - sends t13 info to Jackk")
	end
	
	if (input == "listmail") then
		 SellRunsListMailingDB()
	end
	
	if (input == "sync") then
		ChatFrame1:AddMessage("Requested sync.")
		SendAddonMessage("SellRuns", "ReqSync", "GUILD")
		--SendAddonMessage("SellRuns", "ReqSync", "PARTY")
		if (extraValue == "1") then
			syncDispFlag = true
		else
			syncDispFlag = false
		end
	end
	if (input == "t13") then
		for i=1, t13size, 1 do
			SendChatMessage(t13[i], "WHISPER", nil, extraValue)
		end
		SellRuns:AddToDB(extraValue, 4)
	end
	if (input == "t12") then
		for i=1, t13size, 1 do
			SendChatMessage(t12[i], "WHISPER", nil, extraValue)
		end
		SellRuns:AddToDB(extraValue, 2)
	end
	if (input == "t11") then
		for i=1, t13size, 1 do
			SendChatMessage(t11[i], "WHISPER", nil, extraValue)
		end
		SellRuns:AddToDB(extraValue, 1)
	end
	if (input == "debug") then
		
	end
end

function SellRuns:AddToDB(name, interestWhisper , curdate, curtime)
	local found = 0
	name = name:gsub("^%l", string.upper)
	-- TODO: check if player exists/online
	if (curdate == nil) then
		curdate = date("%d/%m/%y")
		curtime = date("%H:%M:%S")
	end
	if type(SellRunsDB) ~= "table" then		-- initializing a new array
		SellRunsDB = {}
		SellRunsDB[name] = {}
		SellRunsDB[name]["antiSpamTime"] = seconds
		SellRunsDB[name]["warnsRemaining"] = warnings
		SellRunsDB[name]["date"] = curdate
		SellRunsDB[name]["time"] = curtime
		SellRunsDB[name]["interest"] = interestWhisper
	else
			for itername in pairs(SellRunsDB) do 
					 if name == itername then		-- updating existing record
							SellRunsDB[name]["warnsRemaining"] = warnings
							SellRunsDB[name]["antiSpamTime"] = 0
							SellRunsDB[name]["date"] = curdate
							SellRunsDB[name]["time"] = curtime
							interest = SellRunsDB[name]["interest"]
							interest = bit.bor(interest, interestWhisper)
							SellRunsDB[name]["interest"] = interest
							found = 1
					 end
			end
			if found == 0 then		-- adding new record
				SellRunsDB[name] = {}
				SellRunsDB[name]["antiSpamTime"] = 0
				SellRunsDB[name]["warnsRemaining"] = warnings
				SellRunsDB[name]["date"] = curdate
				SellRunsDB[name]["time"] = curtime
				SellRunsDB[name]["interest"] = interestWhisper
		end
	end
	return found
end

function SellRuns:SyncReceiveHandler(prefix, msg, sender)
	if (msg == "ReqSync") then
		if (type(SellRunsDB) ~= "table") then 
			SendAddonMessage("SellRuns", "DBEmpty", "GUILD")
			return
		else
			for name in pairs(SellRunsDB) do
				SendAddonMessage("SellRuns", "SYNC "..sender.." "..name.." "..SellRunsDB[name]["date"].." "..SellRunsDB[name]["time"].." "..SellRunsDB[name]["interest"], "GUILD")
				--SendAddonMessage("SellRuns", "SYNC "..sender.." "..name.." "..SellRunsDB[name]["date"].." "..SellRunsDB[name]["time"].." "..SellRunsDB[name]["interest"], "PARTY")
			end
		end
	end
	
	if (msg == "DBEmpty") then
		ChatFrame1:AddMessage("SYNCED (" .. sender .. ") DB was empty.")
	end
	
	if (string.sub(msg,1,4) == "SYNC") then
		local inputs = {strsplit(" ", msg)}
		if (UnitName("player") == inputs[2]) and (UnitName("player") ~= sender) then	-- only person requesting gets sync'd, also skips reports from self
			local found = SellRuns:AddToDB(inputs[3], inputs[6], inputs[4], inputs[5])
			
			if (syncDispFlag) and (found == 0) then
				ChatFrame1:AddMessage("SYNCED (" .. sender .. ") Name: " .. inputs[3] .. " Last whisper: " .. inputs[4] .. " " .. inputs[5] .. " Interests: " .. inputs[6])
			end
		end
	end
end

function SellRuns:NameSort()
	local found = 0
	local temp = ""
	if (currOrder == "desc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(globalTable[j] < globalTable[j+1]) then
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	elseif (currOrder == "asc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(globalTable[j] > globalTable[j+1]) then
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	else return end
end

function SellRuns:IgnoredSort()
	local found = 0
	local temp = ""
	if (currOrder == "desc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["warnsRemaining"] >= 0) and (SellRunsDB[globalTable[j+1]]["warnsRemaining"] < 0) then		-- j not ignored, j+1 ignored
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	elseif (currOrder == "asc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["warnsRemaining"] < 0) and (SellRunsDB[globalTable[j+1]]["warnsRemaining"] >= 0) then		-- j ignored, j+i not ignored
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	else return end
end
-- FIX THIS
function SellRuns:LastwSort()
	local found = 0
	local temp = ""
	if (currOrder == "desc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				local str = {strsplit("/", SellRunsDB[globalTable[j]]["date"])}
				local month = 31
				if (str[2]==4) or (str[2]==6) or (str[2]==9) or (str[2]==11) then
					month = 30
				elseif (str[2]==2) then
					month = 28
				end
				local thisTime = (365*str[3]+month*str[2]+str[1])*86400
				local str = {strsplit("/", SellRunsDB[globalTable[j+1]]["date"])}
				local month = 31
				if (str[2]==4) or (str[2]==6) or (str[2]==9) or (str[2]==11) then
					month = 30
				elseif (str[2]==2) then
					month = 28
				end
				local nextTime = (365*str[3]+month*str[2]+str[1])*86400
				local str = {strsplit(":", SellRunsDB[globalTable[j]]["time"])}
				thisTime = thisTime + 3600*str[1] + 60*str[2] + str[3]
				local str = {strsplit(":", SellRunsDB[globalTable[j+1]]["time"])}
				nextTime = nextTime + 3600*str[1] + 60*str[2] + str[3]
				if (thisTime > nextTime) then
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	elseif (currOrder == "asc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
								local str = {strsplit("/", SellRunsDB[globalTable[j]]["date"])}
				local month = 31
				if (str[2]==4) or (str[2]==6) or (str[2]==9) or (str[2]==11) then
					month = 30
				elseif (str[2]==2) then
					month = 28
				end
				local thisTime = (365*str[3]+month*str[2]+str[1])*86400
				local str = {strsplit("/", SellRunsDB[globalTable[j+1]]["date"])}
				local month = 31
				if (str[2]==4) or (str[2]==6) or (str[2]==9) or (str[2]==11) then
					month = 30
				elseif (str[2]==2) then
					month = 28
				end
				local nextTime = (365*str[3]+month*str[2]+str[1])*86400
				local str = {strsplit(":", SellRunsDB[globalTable[j]]["time"])}
				thisTime = thisTime + 3600*str[1] + 60*str[2] + str[3]
				local str = {strsplit(":", SellRunsDB[globalTable[j+1]]["time"])}
				nextTime = nextTime + 3600*str[1] + 60*str[2] + str[3]
				if (thisTime < nextTime) then
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	else return end
end

function SellRuns:LastaSort()
	local found = 0
	local temp = ""
	if (currOrder == "desc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["antiSpamTime"] == 0) and (SellRunsDB[globalTable[j+1]]["antiSpamTime"] ~= 0) then		-- j manually added, j+1 autoresponded
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	elseif (currOrder == "asc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["antiSpamTime"] ~= 0) and (SellRunsDB[globalTable[j+1]]["antiSpamTime"] == 0) then		-- j autoresponded, j+1 manually added
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	else return end
end

function SellRuns:InterestsSort()
	local found = 0
	local temp = ""
	if (currOrder == "desc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["interest"] > SellRunsDB[globalTable[j+1]]["interest"]) then		-- j manually added, j+1 autoresponded
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	elseif (currOrder == "asc") then
		for i=1, (#globalTable-1) do
			found = 0
			for j=1, (#globalTable-1) do
				if(SellRunsDB[globalTable[j]]["interest"] < SellRunsDB[globalTable[j+1]]["interest"]) then		-- j autoresponded, j+1 manually added
					temp = globalTable[j]
					globalTable[j] = globalTable[j+1]
					globalTable[j+1] = temp
					found = 1
				end
			end
			if (found == 0) then return end
		end
	else return end
end

function SellRunsUpdate()
	FauxScrollFrame_Update(SellRuns_MainFormEntryListScrollFrame, #globalTable, MAX_ENTRIES, 14, SellRuns_TableBrowserEntry, 482, 498 , SellRuns_TableBrowserHeaderName, 150, 177)
	local str = ""
	for i=1, MAX_ENTRIES do
		local entry = globalTable[i + SellRuns_MainFormEntryListScrollFrame.offset]
		local frame = getglobal("SellRuns_MainFormEntryListEntry"..i)
		if entry then
			frame:Show()
			getglobal(frame:GetName().."Name"):SetText(entry)		-- Name
			--SellRunsDebugMsg("DEBUG: Scroll new entry="..entry)
			if (SellRunsDB[entry]["warnsRemaining"] < 0) then		-- it's being set to -1 anyway, not just decremented after spamming with 0 warns left
				str = "Yes"
			else
				str = "No"
			end
			getglobal(frame:GetName().."Ignored"):SetText(str)		-- Ignored
			
			str = SellRunsDB[entry]["date"].." "..SellRunsDB[entry]["time"]
			getglobal(frame:GetName().."Lastw"):SetText(str)		-- Last Whisper
			
			if (SellRunsDB[entry]["antiSpamTime"] == 0) then		-- it's being set to -1 anyway, not just decremented after spamming with 0 warns left
				str = "Manual"
			else
				str = "Auto"
			end
			getglobal(frame:GetName().."Lasta"):SetText(str)		-- Last Answer
			
			str = ""
			if (bit.band(SellRunsDB[entry]["interest"], 1) == 1) then
				str = str .. "t11 "
			end
			if (bit.band(SellRunsDB[entry]["interest"], 2) == 2) then
				str = str .. "t12 "
			end
			if (bit.band(SellRunsDB[entry]["interest"], 4) == 4) then
				str = str .. "t13 "
			end
			getglobal(frame:GetName().."Interests"):SetText(str)	-- Interests
			
			if entry.isSelected then
				getglobal(frame:GetName().."BG"):Show()
			else
				getglobal(frame:GetName().."BG"):Hide()
			end
		else
			frame:Hide()
		end
	end
end

function SellRunsSortEntries(id)
	if type(SellRunsDB) ~= "table" then return end
	
	if (currSort == id) then
		if (currOrder == "desc") then
			currOrder = "asc"
		else
			currOrder = "desc"
		end
	else
		currSort = id
		currOrder = "asc"
	end
	
	if (currSort == 0) then			-- Name
		SellRuns:NameSort()
	elseif (currSort == 1) then		-- Ignored (Yes/No)
		SellRuns:IgnoredSort()
	elseif (currSort == 2) then		-- Last Whisper (format: d/m/y h:m:s)
		SellRuns:LastwSort()
	elseif (currSort == 3) then		-- Last Answer (Auto/Manual)
			SellRuns:LastaSort()
	elseif (currSort == 4) then		-- Interests
			SellRuns:InterestsSort()
	end
	SellRunsUpdate()
end

function SellRunsFillTableAll()
	if type(SellRunsDB) ~= "table" then return end
	while (globalTable[1] ~= nil) do table.remove(globalTable,1) end
	local i=1
	for name in pairs(SellRunsDB) do 
		table.insert(globalTable,i,name)
		i=i+1
	end
	currOrder = "asc"
	SellRuns:NameSort()
	SellRunsUpdate()
end

function SellRunsFillTableIgnored()
	if type(SellRunsDB) ~= "table" then return end
	while (globalTable[1] ~= nil) do table.remove(globalTable,1) end
	local i=1
	for name in pairs(SellRunsDB) do
		if (SellRunsDB[name]["warnsRemaining"] < 0) then
			table.insert(globalTable,i,name)
		end
		i=i+1
	end
	currOrder = "asc"
	SellRuns:NameSort()
	SellRunsUpdate()
end

function SellRunsT13()
	local input = SellRuns_EditBoxName:GetText()
	if (input == "") then return end
	for i=1, t13size, 1 do
			SendChatMessage(t13[i], "WHISPER", nil, input)
		end
	SellRuns:AddToDB(input, 4)
end

function SellRunsT12()
	local input = SellRuns_EditBoxName:GetText()
	if (input == "") then return end
	for i=1, t12size, 1 do
			SendChatMessage(t12[i], "WHISPER", nil, input)
		end
	SellRuns:AddToDB(input, 2)
end

function SellRunsT11()
	local input = SellRuns_EditBoxName:GetText()
	if (input == "") then return end
	for i=1, t11size, 1 do
			SendChatMessage(t11[i], "WHISPER", nil, input)
		end
	SellRuns:AddToDB(input, 1)
end

function SellRunsMailingQueueUpdate()
	if type(SellRunsMailQueue) ~= "table" then return end
	for i=1, MAX_MAIL_ENTRIES do
		local frame = getglobal("SellRuns_MailingEntryListEntry"..i)
		if (SellRunsMailQueue[i]) then
			frame:Show()
			getglobal(frame:GetName().."Name"):SetText(SellRunsMailQueue[i]["name"])
			if SellRunsMailQueue[i]["invite"] == 0 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Unavailable")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 1 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Invited")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 2 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Accepted")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 3 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Declined")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 4 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Confirmed")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 5 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Out")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 6 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Standby")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(ORANGE_FONT_COLOR.r, ORANGE_FONT_COLOR.g, ORANGE_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 7 then
				getglobal(frame:GetName().."CalendarInvite"):SetText("Signed up")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b)
			elseif SellRunsMailQueue[i]["invite"] == 9 then			-- what's 8?
				getglobal(frame:GetName().."CalendarInvite"):SetText("Tentative")
				getglobal(frame:GetName().."CalendarInvite"):SetTextColor(ORANGE_FONT_COLOR.r, ORANGE_FONT_COLOR.g, ORANGE_FONT_COLOR.b)
			else
				SellRunsDebugMsg("Unsupported invite type: "..SellRunsMailQueue[i]["invite"].." Player: "..SellRunsMailQueue[i]["name"])
			end
			if (SellRunsMailQueue[i]["amount"] == 1) then
				getglobal(frame:GetName().."Full"):SetChecked(true)
			else
				getglobal(frame:GetName().."Full"):SetChecked(false)
			end
			if (SellRunsMailQueue[i]["amount"] == 0) then
				getglobal(frame:GetName().."Half"):SetChecked(true)
			else
				getglobal(frame:GetName().."Half"):SetChecked(false)
			end
		else
			frame:Hide()
		end
	end
end

function SellRunsAddToMailingQueue()
	local name = SellRuns_EditBoxMailName:GetText():gsub("^%l", string.upper) 
	if (name == "") then return end
	if (name == UnitName("player")) then
		ChatFrame1:AddMessage("You can't add yourself")
		return
	end
	if type(SellRunsMailQueue) ~= "table" then	
		SellRunsMailQueue = {}
		SellRunsMailQueue[1] = {}
		SellRunsMailQueue[1]["name"] = name
		SellRunsMailQueue[1]["amount"] = 1		-- 1 - full amount, 0 - half
		SellRunsMailQueue[1]["invite"] = 0
	else
		local found = false
		for i in pairs(SellRunsMailQueue) do
			if name == SellRunsMailQueue[i]["name"] then
				found = true
			end
		end
		if not found then
			SellRunsMailQueue[table.getn(SellRunsMailQueue)+1] = {}
			SellRunsMailQueue[table.getn(SellRunsMailQueue)]["name"] = name	 -- not table.getn(SellRunsMailQueue)+1 anymore
			SellRunsMailQueue[table.getn(SellRunsMailQueue)]["amount"] = 1	 -- as we already added new entry above
			SellRunsMailQueue[table.getn(SellRunsMailQueue)]["invite"] = 0
		end
	end
	SellRunsMailingQueueUpdate()
end

function SellRunsMailRemoveEntry(id)
	table.remove(SellRunsMailQueue,id)
	SellRunsMailingQueueUpdate()
end

function SellRunsMailingQueueAmountClick(self, id)
	if self == getglobal("SellRuns_MailingEntryListEntry"..id.."Full") then
		SellRunsMailQueue[id]["amount"] = 1
	elseif self == getglobal("SellRuns_MailingEntryListEntry"..id.."Half") then
		SellRunsMailQueue[id]["amount"] = 0
	end
	SellRunsMailingQueueUpdate()
end

function SellRunsEditMail()
	if ( SellRuns_EditMail:IsShown() ) then
			SellRuns_EditMail:Hide()
		else
			SellRuns_EditMail:Show()
		end
end

function SellRunsMailFailed()
	if (SellRuns_MailingSend:GetButtonState() ~= "DISABLED") then return end	-- mail wasn't sent through this addon
	ChatFrame1:AddMessage("SellRuns: Failed to send mail to "..SellRunsMailQueue[SellRunsMailCurrent-1]["name"]..". Skipping.")
end

function SellRunsGold2Str(amount)
	local gold = floor(abs(amount / 10000))
	local silver = floor(abs(mod(amount / 100, 100)))
	local copper = floor(abs(mod(amount, 100)))
	local str = gold..'g '..silver..'s '..copper..'c'
	return str
end

function SellRunsMailContentUpdate()			
	local gbankTotal = 0
	if (SellRunsMailGold ~= "" ) then
		if (table.getn(SellRunsMailQueue) > 0) then
			for i=1, table.getn(SellRunsMailQueue) do
				if (SellRunsMailQueue[i]["amount"] == 0) then
					gbankTotal = gbankTotal + (SellRunsMailGold / (table.getn(SellRunsMailQueue)+1) / 2)
				end
			end
		end
	end
	local goldStr = SellRunsGold2Str(SellRunsMailGold)
	gbankStr = SellRunsGold2Str(gbankTotal)
	local personalStr = SellRunsGold2Str(SellRunsGoldToSend)
	local amountStr = ""
	if (SellRunsMailQueue[SellRunsMailCurrent]["amount"] == 1) then		-- full amount
		amountStr = "Full"
	else																-- half
		amountStr = "Half"
	end
	local calendarInvite = "Unsupported"
	if SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 0 then
		calendarInvite = "Unavailable / Uninvited"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 1 then
		calendarInvite = "Invited"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 2 then
		calendarInvite = "Accepted"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 3 then
		calendarInvite = "Declined"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 4 then
		calendarInvite = "Confirmed"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 5 then
		calendarInvite = "Out"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 6 then
		calendarInvite = "Standby"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 7 then
		calendarInvite = "Signed up"
	elseif SellRunsMailQueue[SellRunsMailCurrent]["invite"] == 9 then
		calendarInvite = "Tentative"
	end
	SellRunsMailSubjectToSend = SellRunsMailSubject
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/date/", date("%d/%m/%y"))		-- local date
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/time/", date("%H:%M:%S"))		-- local time
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/reason/", SellRunsMailReason)	-- reason for getting the mail
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/totalgold/", goldStr)	-- total amount of gold to be split
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/personalgold/", personalStr)		-- personal gold gain
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/gbank/", gbankStr)			-- gbank gold gain
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/from/", UnitName("player"))	-- sender
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/to/", SellRunsMailQueue[SellRunsMailCurrent]["name"])	-- receiver
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/amount/", amountStr)			-- string "Full" or "Half"
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/zone/", GetRealZoneText())		-- sender's zone
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/subzone/", GetSubZoneText())	-- sender's subzone
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/mailcount/", SellRunsMailCurrent)	-- which mail out of all queued
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/totalmail/", table.getn(SellRunsMailQueue)) -- total mail count
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/invite/", calendarInvite)	-- calendar invite status
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/event/", SellRunsEventName)	-- event name for invites
	SellRunsMailSubjectToSend = string.gsub(SellRunsMailSubjectToSend, "/postage/", SellRunsGold2Str(SellRunsPostage))	-- postage
	SellRunsMailBodyToSend = SellRunsMailBody
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/date/", date("%d/%m/%y"))		-- local date
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/time/", date("%H:%M:%S"))		-- local time
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/reason/", SellRunsMailReason)	-- reason for getting the mail
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/totalgold/", goldStr)	-- total amount of gold to be split
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/personalgold/", personalStr)		-- personal gold gain
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/gbank/", gbankStr)				-- gbank gold gain
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/from/", UnitName("player"))		-- sender
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/to/", SellRunsMailQueue[SellRunsMailCurrent]["name"])	-- receiver
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/amount/", amountStr)			-- string "Full" or "Half"
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/zone/", GetRealZoneText())		-- sender's zone
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/subzone/", GetSubZoneText())	-- sender's subzone
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/mailcount/", SellRunsMailCurrent)	-- which mail out of all queued
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/totalmail/", table.getn(SellRunsMailQueue)) -- total mail count
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/invite/", calendarInvite)	-- calendar invite status
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/event/", SellRunsEventName)	-- event name for invites
	SellRunsMailBodyToSend = string.gsub(SellRunsMailBodyToSend, "/postage/", SellRunsGold2Str(SellRunsPostage))	-- postage
end

function SellRunsSendMail()
	SellRunsMailCurrent = 1
	if(not SendMailSubjectEditBox:IsVisible()) then		
		ChatFrame1:AddMessage("Mailbox must be opened on 'Send Mail' tab.")
		return
	end	
	if (table.getn(SellRunsMailQueue) == 0) then
		ChatFrame1:AddMessage("Mailing queue is empty.")
		return
	end
	SellRunsMailReason = SellRuns_EditBoxMailReason:GetText();
	SellRunsMailGold = SellRuns_EditBoxMailGold:GetText() * 10000;
	-- add if SellRunsMailGold exceeds current amount of gold?
	SellRuns_MailingSend:Disable()
	SellRunsCanSend = true
end

function SellRunsMailProcess()
	SellRunsCanSend = false
	if (SellRunsMailCurrent > table.getn(SellRunsMailQueue) and SellRuns_MailingSend:GetButtonState() == "DISABLED") then
		ChatFrame1:AddMessage("SellRuns: Ended sending mails. Guild bank should receive: "..gbankStr)
		SellRuns_MailingSend:Enable()
		return
	end
	SellRunsGoldToSend = 0
	if SellRunsMailGold ~= "" then
		if (SellRunsMailQueue[SellRunsMailCurrent]["amount"] == 1) then
			SellRunsGoldToSend = SellRunsMailGold / (table.getn(SellRunsMailQueue)+1)
		else
			SellRunsGoldToSend = SellRunsMailGold / (table.getn(SellRunsMailQueue)+1) / 2
		end
		SellRunsGoldToSend = SellRunsGoldToSend - SellRunsPostage
		if (SellRunsGoldToSend < 0) then
			SellRunsGoldToSend = 0
		end
		math.floor(SellRunsGoldToSend)
	end
	SellRunsMailContentUpdate()
	SetSendMailMoney(SellRunsGoldToSend)
	SellRunsDebugMsg("Sending mail "..SellRunsMailCurrent.."/"..table.getn(SellRunsMailQueue))
	SendMail(SellRunsMailQueue[SellRunsMailCurrent]["name"], SellRunsMailSubjectToSend, SellRunsMailBodyToSend)
	SellRunsMailCurrent = SellRunsMailCurrent+1
end

function SellRunsMailingUpdateInvites()
	for i in pairs(SellRunsMailQueue) do
		SellRunsMailQueue[i]["invite"] = 0
	end
	SellRunsEventName = "Unavailable"
	SellRunsMailingQueueUpdate()
	curEvent = 1
	SellRunsDebugMsg("Updating calendar invites")
	SellRuns_MailingCalendarInvites:Disable()
	CalendarSetAbsMonth(date("%m"))
	OpenCalendar()
end

function SellRunsCalendarInvitesHandler(event)
	if (curEvent == -1) then return end
	if (event == "CALENDAR_UPDATE_EVENT_LIST") then
		SellRunsRequestedInvUpdate = true
		eventCount = CalendarGetNumDayEvents(0, date("%d"))
	elseif (event == "CALENDAR_OPEN_EVENT") then
		for i=1, CalendarEventGetNumInvites() do
			name, _, _, _, inviteStatus, modStatus = CalendarEventGetInvite(i)
			if (name == UnitName("player") and (modStatus == "CREATOR" or modStatus == "MODERATOR")) then
				-- seems like a valid event, let's update!
				for i=1, CalendarEventGetNumInvites() do
					itrName, _, _, _, itrInviteStatus = CalendarEventGetInvite(i)
					for j in pairs(SellRunsMailQueue) do
						if (itrName == SellRunsMailQueue[j]["name"]) then
							eventName, _, _, _, _, _, _, _, _, eventDay = CalendarGetEventInfo()
							if (tonumber(date("%d")) == eventDay) then
								SellRunsMailQueue[j]["invite"] = itrInviteStatus
								SellRunsEventName = eventName
								SellRunsMailingQueueUpdate()
							end
						end
					end
				end
				break
			end
		end
		curEvent = curEvent+1
		if (curEvent > eventCount) then
			curEvent = -1
			SellRunsRequestedInvUpdate = false
			if (SellRunsEventName ~= "Unavailable") then
				ChatFrame1:AddMessage("SellRuns: Updated from today's event: "..SellRunsEventName)
			else
				ChatFrame1:AddMessage("SellRuns: You are not a moderator of any of today's events. Update not possible.")
			end
			SellRuns_MailingCalendarInvites:Enable()
			return
		end
		SellRunsRequestedInvUpdate = true
	else return end
end

function SellRunsMailingAddToDB()
	if (SellRuns_MailingSend:GetButtonState() ~= "DISABLED") then return end	-- mail wasn't sent through this addon
	local gbankTotal = 0
	if (SellRunsMailGold ~= "" ) then
		if (table.getn(SellRunsMailQueue) > 0) then
			for i=1, table.getn(SellRunsMailQueue) do
				if (SellRunsMailQueue[i]["amount"] == 0) then
					gbankTotal = gbankTotal + (SellRunsMailGold / (table.getn(SellRunsMailQueue)+1) / 2)
				end
			end
		end
	end
	if type(SellRunsMailDB) ~= "table" then	
		SellRunsMailDB = {}
		SellRunsMailDB[1] = {}
		SellRunsMailDB[1]["name"] = SellRunsMailQueue[SellRunsMailCurrent-1]["name"]
		SellRunsMailDB[1]["from"] = UnitName("player")
		SellRunsMailDB[1]["reason"] = SellRunsMailReason
		SellRunsMailDB[1]["amount"] = SellRunsMailQueue[SellRunsMailCurrent-1]["amount"]
		SellRunsMailDB[1]["invite"] = SellRunsMailQueue[SellRunsMailCurrent-1]["invite"]
		SellRunsMailDB[1]["event"] = SellRunsEventName
		SellRunsMailDB[1]["date"] = date("%d/%m/%y")
		SellRunsMailDB[1]["time"] = date("%H:%M:%S")
		SellRunsMailDB[1]["totalgold"] = SellRunsMailGold
		SellRunsMailDB[1]["personalgold"] = SellRunsGoldToSend
		SellRunsMailDB[1]["gbank"] = gbankTotal
		SellRunsMailDB[1]["postage"] = SellRunsPostage
		SellRunsMailDB[1]["mailcount"] = SellRunsMailCurrent-1
		SellRunsMailDB[1]["totalmail"] = table.getn(SellRunsMailQueue)
		SellRunsMailDB[1]["zone"] = GetRealZoneText()
		SellRunsMailDB[1]["subzone"] = GetSubZoneText()
	else
		SellRunsMailDB[table.getn(SellRunsMailDB)+1] = {}
		SellRunsMailDB[table.getn(SellRunsMailDB)]["name"] = SellRunsMailQueue[SellRunsMailCurrent-1]["name"]
		SellRunsMailDB[table.getn(SellRunsMailDB)]["from"] = UnitName("player")
		SellRunsMailDB[table.getn(SellRunsMailDB)]["reason"] = SellRunsMailReason
		SellRunsMailDB[table.getn(SellRunsMailDB)]["amount"] = SellRunsMailQueue[SellRunsMailCurrent-1]["amount"]
		SellRunsMailDB[table.getn(SellRunsMailDB)]["invite"] = SellRunsMailQueue[SellRunsMailCurrent-1]["invite"]
		SellRunsMailDB[table.getn(SellRunsMailDB)]["event"] = SellRunsEventName
		SellRunsMailDB[table.getn(SellRunsMailDB)]["date"] = date("%d/%m/%y")
		SellRunsMailDB[table.getn(SellRunsMailDB)]["time"] = date("%H:%M:%S")
		SellRunsMailDB[table.getn(SellRunsMailDB)]["totalgold"] = SellRunsMailGold
		SellRunsMailDB[table.getn(SellRunsMailDB)]["personalgold"] = SellRunsGoldToSend
		SellRunsMailDB[table.getn(SellRunsMailDB)]["gbank"] = gbankTotal
		SellRunsMailDB[table.getn(SellRunsMailDB)]["postage"] = SellRunsPostage
		SellRunsMailDB[table.getn(SellRunsMailDB)]["mailcount"] = SellRunsMailCurrent-1
		SellRunsMailDB[table.getn(SellRunsMailDB)]["totalmail"] = table.getn(SellRunsMailQueue)
		SellRunsMailDB[table.getn(SellRunsMailDB)]["zone"] = GetRealZoneText()
		SellRunsMailDB[table.getn(SellRunsMailDB)]["subzone"] = GetSubZoneText()
	end
	SellRunsDebugMsg("Added to Mailing DB")
end

function SellRunsListMailingDB()
	if type(SellRunsMailDB) ~= "table" then	return end
	for i in pairs(SellRunsMailDB) do
		ChatFrame1:AddMessage(i..": "..SellRunsMailDB[i]["name"])
	end
end

function SellRunsIsSelected(id)		-- TODO
	--SellRunsDebugMsg("IsSelected ID=" .. id)
end

function SellRunsSelectEntry(id)	-- TODO
	-- SellRunsDebugMsg("Selected entry. ID=" .. id)
end

function SellRunsTODO(id)			-- SHITTONS TO DO
	SellRunsDebugMsg("Not Yet Implemented")
end